"""Raw representations of every data type in the AWS DataPipeline service.

See Also:
    `AWS developer guide for DataPipeline
    <https://docs.aws.amazon.com/step-functions/latest/dg/welcome.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = ["Pipeline", "PipelineProperties"]


@attrs(**ATTRSCONFIG)
class PipelineProperties(ResourceProperties):
    Activate = attrib(default=None)
    Description = attrib(default=None)
    Name = attrib(default=None)
    ParameterObjects = attrib(default=None)
    ParameterValues = attrib(default=None)
    PipelineObjects = attrib(default=None)
    PipelineTags = attrib(default=None)


@attrs(**ATTRSCONFIG)
class Pipeline(Resource):
    """A Pipeline for DataPipeline.

    See Also:
        `AWS Cloud Formation documentation for Pipeline
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-datapipeline-pipeline.html>`_
    """

    RESOURCE_TYPE = "AWS::DataPipeline::Pipeline"

    Properties: PipelineProperties = attrib(
        factory=PipelineProperties,
        converter=create_object_converter(PipelineProperties),
    )
