"""Raw representations of every data type in the AWS FSx service.

See Also:
    `AWS developer guide for FSx
    <https://docs.aws.amazon.com/fsx/latest/WindowsGuide/index.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = ["FileSystem", "FileSystemProperties"]


@attrs(**ATTRSCONFIG)
class FileSystemProperties(ResourceProperties):
    BackupId = attrib(default=None)
    FileSystemType = attrib(default=None)
    KmsKeyId = attrib(default=None)
    LustreConfiguration = attrib(default=None)
    SecurityGroupIds = attrib(default=None)
    StorageCapacity = attrib(default=None)
    SubnetIds = attrib(default=None)
    Tags = attrib(default=None)
    WindowsConfiguration = attrib(default=None)


@attrs(**ATTRSCONFIG)
class FileSystem(Resource):
    """A File System for FSx.

    See Also:
        `AWS Cloud Formation documentation for FileSystem
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fsx-filesystem.html>`_
    """

    RESOURCE_TYPE = "AWS::FSx::FileSystem"

    Properties: FileSystemProperties = attrib(
        factory=FileSystemProperties,
        converter=create_object_converter(FileSystemProperties),
    )
