"""Raw representations of every data type in the AWS MediaStore service.

See Also:
    `AWS developer guide for MediaStore
    <https://docs.aws.amazon.com/mediastore/latest/ug/what-is.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = ["Container", "ContainerProperties"]


@attrs(**ATTRSCONFIG)
class ContainerProperties(ResourceProperties):
    AccessLoggingEnabled = attrib(default=None)
    ContainerName = attrib(default=None)
    CorsPolicy = attrib(default=None)
    LifecyclePolicy = attrib(default=None)
    Policy = attrib(default=None)


@attrs(**ATTRSCONFIG)
class Container(Resource):
    """A Container for MediaStore.

    See Also:
        `AWS Cloud Formation documentation for Container
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-mediastore-container.html>`_
    """

    RESOURCE_TYPE = "AWS::MediaStore::Container"

    Properties: ContainerProperties = attrib(
        factory=ContainerProperties,
        converter=create_object_converter(ContainerProperties),
    )
