"""Raw representations of every data type in the AWS SDB service.

See Also:
    `AWS developer guide for SDB
    <https://docs.aws.amazon.com/AmazonSimpleDB/latest/DeveloperGuide/index.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = ["Domain", "DomainProperties"]


@attrs(**ATTRSCONFIG)
class DomainProperties(ResourceProperties):
    Description = attrib(default=None)


@attrs(**ATTRSCONFIG)
class Domain(Resource):
    """A Domain for SDB.

    See Also:
        `AWS Cloud Formation documentation for Domain
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-simpledb.html>`_
    """

    RESOURCE_TYPE = "AWS::SDB::Domain"

    Properties: DomainProperties = attrib(
        factory=DomainProperties, converter=create_object_converter(DomainProperties)
    )
